using System.Windows.Media.Media3D;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public struct LineRange
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ʈ 1
        /// </summary>
        private Point3D point1;

        /// <summary>
        /// Ʈ 2
        /// </summary>
        private Point3D point2;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ʈ 1 - Point1

        /// <summary>
        /// Ʈ 1
        /// </summary>
        public Point3D Point1
        {
            set
            {
                this.point1 = value;
            }
            get
            {
                return this.point1;
            }
        }

        #endregion
        #region Ʈ 2 - Point2

        /// <summary>
        /// Ʈ 2
        /// </summary>
        public Point3D Point2
        {
            set
            {
                this.point2 = value;
            }
            get
            {
                return point2;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - LineRange(point1, point2)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="point1">Ʈ 1</param>
        /// <param name="point2">Ʈ 2</param>
        public LineRange(Point3D point1, Point3D point2)
        {
            this.point1 = point1;
            this.point2 = point2;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region X Ʈ ϱ - PointFromX(x)

        /// <summary>
        /// X Ʈ ϱ
        /// </summary>
        /// <param name="x">X ǥ</param>
        /// <returns>Ʈ</returns>
        public Point3D PointFromX(double x)
        {
            double factor = (x - Point1.X) / (Point2.X - Point1.X);

            double y = Point1.Y + factor * (Point2.Y - Point1.Y);
            double z = Point1.Z + factor * (Point2.Z - Point1.Z);

            return new Point3D(x, y, z);
        }

        #endregion
        #region Y Ʈ ϱ - PointFromY(y)

        /// <summary>
        /// Y Ʈ ϱ
        /// </summary>
        /// <param name="y">Y ǥ</param>
        /// <returns>Ʈ</returns>
        public Point3D PointFromY(double y)
        {
            double factor = (y - Point1.Y) / (Point2.Y - Point1.Y);

            double x = Point1.X + factor * (Point2.X - Point1.X);
            double z = Point1.Z + factor * (Point2.Z - Point1.Z);

            return new Point3D(x, y, z);
        }

        #endregion
        #region Z Ʈ ϱ - PointFromZ(z)

        /// <summary>
        /// Z Ʈ ϱ
        /// </summary>
        /// <param name="z">Z ǥ</param>
        /// <returns>Ʈ</returns>
        public Point3D PointFromZ(double z)
        {
            double factor = (z - Point1.Z) / (Point2.Z - Point1.Z);

            double x = Point1.X + factor * (Point2.X - Point1.X);
            double y = Point1.Y + factor * (Point2.Y - Point1.Y);

            return new Point3D(x, y, z);
        }

        #endregion
    }
}